#include "init.h"

extern HWND		hWnd;		    //init.cpp - Holds Our Window Handle
extern HINSTANCE	hInstance;	//init.cpp - Holds The Instance Of The Application
extern const int screen_x;      //init.cpp - screen width
extern const int screen_y;      //init.cpp - screen height
extern bool	keys[256];			//init.cpp - Array Used For The Keyboard Routine
extern GLfloat LightPosition[4];//init.cpp
GLuint BuildListsPaintBall(float ,int ,int ,GLuint );	//lists.cpp
GLuint BuildListsStars(GLuint );		//stars.cpp
GLuint BuildListsLines(GLuint );		//stars.cpp
void ChangeCameraPosition(void);		//apocalypse.cpp
int  DrawGLSceneDemo(GLvoid);           //apocalypse.cpp
inline void write_text(void);			//apocalypse.cpp
void ChangeCameraPositionDemo(void);	//camerademo.cpp
#include "timer.h"
extern TIMER time_,timer1;		        //timer.cpp
float TimerGetTime(TIMER*);				//timer.cpp
void TimerReset(TIMER*);				//timer.cpp
void ShowMenu(void);					//menu.cpp
GLvoid glPrintFast(GLint , GLint , char *, int );  //bitmap_font.cpp

const float piover180 = 0.01745329252f; // pi/180
float scale_planet=1/2.0f,scale_distance=1/2000.0f,scale_sun=1/50.0f,scale_moon=75.0f;

#define NUMBER_TEXTURE 13

char texture_name[NUMBER_TEXTURE][30]=
	{"data/font.bmp","data/sun.bmp","data/mercury.bmp","data/venus.bmp",
	 "data/earth.bmp","data/moon.bmp","data/mars.bmp","data/jupiter.bmp",
    "data/sunshine.bmp","data/clouds.bmp","data/star.bmp","data/star.bmp","data/flare.bmp"};

GLuint	texture[NUMBER_TEXTURE];

float angle_x,angle_y,angle_z,pos_x=0,pos_y=0,pos_z=30.0,fps,stime,yearsec=30.0f/(float)365.256;
int rotate_s=1,rotate=1;  //rotate around sun,rotate planet
POINT MouseBod;
int sphere_split_y=8,frame=0,menu=0,change_split=2;
int demomode=1,optimalization=1,light=1,showFps=0,polygonmode=0,conslines=0,showclouds=0,showDel=0,showPos=0,showAngles=0,sound=1;
GLuint	box[3];				// Storage For The Box Display List


int DrawGLScene(GLvoid)		// Here's Where We Do All The Drawing
{float scale;
float ang_s_mercury,ang_s_venus,ang_s_earth,ang_s_moon,ang_s_mars,ang_s_jupiter;  //ANGle_around Sun_PLANET (orbital)
float ang_mercury,ang_venus,ang_earth,ang_moon,ang_mars,ang_jupiter,ang_sun;  //ANGle_PLANET (rotation)
 
 if(demomode){return DrawGLSceneDemo();}
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );	// Clear Screen And Depth Buffer
  ChangeCameraPosition();
  if(polygonmode) glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
  if(keys[VK_SPACE]){if(menu)menu=0;else menu=1; keys[VK_SPACE]=0;}
  if(optimalization)if(frame>1)
  {
  if(fps>50.0){if(sphere_split_y<40){sphere_split_y+=2;change_split=1;frame=0;}}
  else if(fps<25.0)if(sphere_split_y>8){sphere_split_y-=2;change_split=1;frame=0;}
  }

  if(change_split)
  {
    box[0]=BuildListsPaintBall(1.0f,2*sphere_split_y,sphere_split_y,box[0]);
    if(change_split==2){ box[1]=BuildListsStars(box[1]);
	box[2]=BuildListsLines(box[2]);}
    change_split=0;
  }

  stime=(float)TimerGetTime(&time_);

  if(rotate_s==1)			//calculation angle for rotate planets around sun
  {  ang_s_mercury=360.0f*stime*yearsec*piover180*365.256f/87.969f;
     ang_s_venus=  360.0f*stime*yearsec*piover180*365.256f/224.701f;
     ang_s_earth=  360.0f*stime*yearsec*piover180*365.256f/365.256f; //365.256 rotate around sun  for 1 year
     ang_s_moon=   360.0f*stime*yearsec*piover180*365.256f/27.32166f;
     ang_s_mars=   360.0f*stime*yearsec*piover180*365.256f/686.98f;
     ang_s_jupiter=360.0f*stime*yearsec*piover180*365.256f/4332.71f;
  }
  else if(rotate_s==2)
  {ang_s_mercury=0;ang_s_venus=0;ang_s_earth=0;ang_s_moon=0;ang_s_mars=0;ang_s_jupiter=0;rotate_s=0;  }

  if(rotate)        //calculation angle for rotate planets
  {  ang_mercury=360.0f*stime*yearsec*365.256f/58.6462f;
     ang_venus= -360.0f*stime*yearsec*365.256f/243.0187f;
     ang_earth=  360.0f*stime*yearsec*365.256f/0.99727f;      //0.99727 (or 1.0 ?) rotate for 1 day
     ang_moon=   360.0f*stime*yearsec*365.256f/27.32166f;
     ang_mars=   360.0f*stime*yearsec*365.256f/1.025957f;
     ang_jupiter=360.0f*stime*yearsec*365.256f/0.41354f;
     ang_sun	=360.0f*stime*yearsec*365.256f/25.0f;          //25-36
  }

  glColor3f(1,1,1);
  glPushMatrix();
  if(rotate)glRotatef(ang_sun,0,1,0);
  scale=scale_sun*696;glScalef(scale,scale,scale);
  glBindTexture(GL_TEXTURE_2D, texture[1]);  //sun
  glCallList(box[0]);

  if(light)glEnable(GL_LIGHTING);

  glPopMatrix();glPushMatrix();
  if(rotate_s) glTranslatef(57900*scale_distance*(float)cos(ang_s_mercury),0.0f,-57900*scale_distance*(float)sin(ang_s_mercury));
  else glTranslatef(57900 *scale_distance,0.0f,0.0f);
  LightPosition[0]=-(float)cos(ang_s_mercury);
  LightPosition[2]=(float)sin(ang_s_mercury);
  glLightfv ( GL_LIGHT0,GL_POSITION, LightPosition  );// Position The Light
  //glRotatef(-0.1,0,0,-1);
  if(rotate)glRotatef(ang_mercury,0,1,0);
  scale=scale_planet*2.46f;glScalef(scale,scale,scale);
  glBindTexture(GL_TEXTURE_2D, texture[2]);    //mercury
  glCallList(box[0]);

  glPopMatrix();glPushMatrix();
  if(rotate_s)  glTranslatef(108200*scale_distance*(float)cos(ang_s_venus),0.0f,-108200*scale_distance*(float)sin(ang_s_venus));
  else glTranslatef(108200*scale_distance,0.0f,0.0f);
  LightPosition[0]=-(float)cos(ang_s_venus);
  LightPosition[2]=(float)sin(ang_s_venus);
  glLightfv ( GL_LIGHT0,GL_POSITION, LightPosition  );// Position The Light
  glRotatef(-3,0,0,-1);
  if(rotate)glRotatef(ang_venus,0,1,0);
  scale=scale_planet*6.05f;glScalef(scale,scale,scale);
  glBindTexture(GL_TEXTURE_2D, texture[3]);     //venus
  glCallList(box[0]);


  glPopMatrix();glPushMatrix();
  if(rotate_s)  glTranslatef(149600*scale_distance*(float)cos(ang_s_earth),0.0f,-149600*scale_distance*(float)sin(ang_s_earth));
  else glTranslatef(149600*scale_distance,0.0f,0.0f);
  LightPosition[0]=-(float)cos(ang_s_earth);
  LightPosition[2]=(float)sin(ang_s_earth);
  glLightfv ( GL_LIGHT0,GL_POSITION, LightPosition  );// Position The Light
  glRotatef(23.0,0,0,-1);
  if(rotate)glRotatef(ang_earth,0,1,0);
  scale=scale_planet*6.378f;glScalef(scale,scale,scale);
  glBindTexture(GL_TEXTURE_2D, texture[4]);    //earth
  glCallList(box[0]);

  if(showclouds)
  { glEnable(GL_BLEND);
    scale=1.01f;glScalef(scale,scale,scale);
    glBindTexture(GL_TEXTURE_2D, texture[9]);    //earth clouds
    glCallList(box[0]);
    glDisable(GL_BLEND);
  }

  glPopMatrix();glPushMatrix();
  if(rotate_s)  glTranslatef(149600*scale_distance*(float)cos(ang_s_earth)+384*scale_moon*scale_distance*(float)cos(ang_s_moon),0.0f,-149600*scale_distance*(float)sin(ang_s_earth)-384*scale_moon*scale_distance*(float)sin(ang_s_moon));
  else glTranslatef((149600+384*scale_moon)*scale_distance,0.0f,0.0f);
  //glRotatef(1.5424,0,0,-1);
  LightPosition[0]=-149600*scale_distance*(float)cos(ang_s_earth)+384*scale_moon*scale_distance*(float)cos(ang_s_moon);
  LightPosition[2]=149600*scale_distance*(float)sin(ang_s_earth)-384*scale_moon*scale_distance*(float)sin(ang_s_moon);
  glLightfv ( GL_LIGHT0,GL_POSITION, LightPosition  );// Position The Light
  if(rotate)glRotatef(ang_moon+90.0f,0,1,0);
  scale=scale_planet*1.738f;glScalef(scale,scale,scale);
  glBindTexture(GL_TEXTURE_2D, texture[5]);    //moon
  glCallList(box[0]);

  if(227900*scale_distance<100)
  {  glPopMatrix();glPushMatrix();
     if(rotate_s)glTranslatef(227900*scale_distance*(float)cos(ang_s_mars),0.0f,-227900*scale_distance*(float)sin(ang_s_mars));
     else glTranslatef(227900*scale_distance,0.0f,0.0f);
     LightPosition[0]=-(float)cos(ang_s_mars);
     LightPosition[2]=(float)sin(ang_s_mars);
     glLightfv ( GL_LIGHT0,GL_POSITION, LightPosition  );// Position The Light
     glRotatef(25.0,0,0,-1);
     if(rotate)glRotatef(ang_mars,0,1,0);
     scale=scale_planet*3.4f;glScalef(scale,scale,scale);
     glBindTexture(GL_TEXTURE_2D, texture[6]);    //mars
     glCallList(box[0]);
  }

  if(778300*scale_distance<100)
  { glPopMatrix();glPushMatrix();
    if(rotate_s)glTranslatef(778300*scale_distance*(float)cos(ang_s_jupiter),0.0f,-778300*scale_distance*(float)sin(ang_s_jupiter));
    else glTranslatef(778300*scale_distance,0.0f,0.0f);
    LightPosition[0]=-(float)cos(ang_s_jupiter);
    LightPosition[2]=(float)sin(ang_s_jupiter);
    glLightfv ( GL_LIGHT0,GL_POSITION, LightPosition  );// Position The Light
    glRotatef(3.0,0,0,-1);
    if(rotate)glRotatef(ang_jupiter,0,1,0);
    scale=scale_planet*71.35f;glScalef(scale,scale,scale);
    glBindTexture(GL_TEXTURE_2D, texture[7]);    //jupiter
    glCallList(box[0]);
  }

  if(light)glDisable(GL_LIGHTING);
  
  glPopMatrix();glPushMatrix();
  glColor3f(1,1,1);
  glBlendFunc(GL_ONE,GL_ONE);
  glEnable(GL_BLEND);
  glBindTexture(GL_TEXTURE_2D, texture[10]);
  glCallList(box[1]);				//stars
  glDisable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_COLOR);

  if(conslines){
    glPopMatrix();glPushMatrix();
    glDisable(GL_TEXTURE_2D);
    glColor3f(1,1,1);
    glCallList(box[2]);				//constalation lines
    glEnable(GL_TEXTURE_2D);
  }

  glColor3f(1,1,1);

   glPopMatrix();//glPushMatrix();
   fps=(float)1.0f /(float)TimerGetTime(&timer1);
   TimerReset(&timer1);

   if(polygonmode)glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
   if(showFps | showDel | showPos | showAngles)write_text(); //write on screen FPS,...
   if(menu)ShowMenu();
	frame++;
	return TRUE;						// Everything Went OK
}

void ChangeCameraPosition(void)
{float mys_x,mys_y,step;
   glLoadIdentity();					// Reset The Current Modelview Matrix
  if(!menu)
  { if(keys['R']){angle_x=0;angle_y=0;angle_z=0;pos_z=50;pos_x=0;pos_y=0;keys['R']=0;}
    if     (keys[VK_NUMPAD6]){if(angle_y==360)angle_y=0;angle_y++;}
    else if(keys[VK_NUMPAD4]){if(angle_y==0)angle_y=360;angle_y--;}
    if     (keys[VK_NUMPAD5]){if(angle_x==360)angle_x=0;angle_x++;}
    else if(keys[VK_NUMPAD8]){if(angle_x==0)angle_x=360;angle_x--;}
    if     (keys[VK_DIVIDE]) {if(angle_z==360)angle_z=0;angle_z++;}
    else if(keys[VK_NUMPAD2]){if(angle_z==0)angle_z=360;angle_z--;}
	if(keys[VK_SHIFT])step=5.0f/fps;else step=25.0f/fps;
	
	if (keys[VK_UP] || keys[VK_LBUTTON])		// sipka hore alebo lave tlacidlo mysi
	{	
		pos_x += step * (float)sin(angle_y*piover180) * (float)cos(angle_x*piover180);
		pos_y -= step * (float)sin(angle_x*piover180);
		pos_z -= step * (float)cos(angle_y*piover180) * (float)cos(angle_x*piover180);
	}
	if (keys[VK_DOWN] || keys[VK_RBUTTON])		// sipka dole alebo prave tlacidlo mysi
	{
		pos_x -= step * (float)sin(angle_y*piover180) * (float)cos(angle_x*piover180);
		pos_y += step * (float)sin(angle_x*piover180);
		pos_z += step * (float)cos(angle_y*piover180) * (float)cos(angle_x*piover180);
	}

	if((pos_x*pos_x+pos_y*pos_y+pos_z*pos_z)>10000.0)
	{
		if (keys[VK_DOWN] || keys[VK_RBUTTON])
		{
			pos_x += step * (float)sin(angle_y*piover180) * (float)cos(angle_x*piover180);
			pos_y -= step * (float)sin(angle_x*piover180);
			pos_z -= step * (float)cos(angle_y*piover180) * (float)cos(angle_x*piover180);
		}
		else
		{
			pos_x -= step * (float)sin(angle_y*piover180) * (float)cos(angle_x*piover180);
			pos_y += step * (float)sin(angle_x*piover180);
			pos_z += step * (float)cos(angle_y*piover180) * (float)cos(angle_x*piover180);
		}
	}

    GetCursorPos(&MouseBod);
    SetCursorPos(400,300);
    mys_x= ((float)MouseBod.x - 400)/10;
    mys_y= ((float)MouseBod.y - 300)/10;
    if		(keys[VK_NEXT])mys_y=1;   //Page Down
    else if(keys[VK_PRIOR])mys_y=-1;  //Page Up
    if		(keys[VK_RIGHT])mys_x=1;
    else if(keys[VK_LEFT])mys_x=-1;
    angle_x+= mys_y;
    angle_y+= mys_x;
	if(angle_x>90.f) angle_x = 90.f;
	if(angle_x<-90.f) angle_x = -90.f;
  }
  glRotatef(angle_x,1,0,0);
  glRotatef(angle_y,0,1,0);
//  glRotatef(angle_z,0,0,1);
  glTranslatef(-pos_x, -pos_y, -pos_z);
}

AUX_RGBImageRec *LoadBMP(char *Filename)			// Natanie bitmapovho obrzka
{
	FILE *File=NULL;								// smernik na subor

	if (!Filename)return NULL;						// skka i meno sboru bolo zadan
	File=fopen(Filename,"r");						// otvorenie sboru na tanie
	if (File)										// existuje sbor ?
	{
		fclose(File);								// Uzatvorenie sbora
		return auxDIBImageLoad(Filename);			// Nata obrzok a vrti pointer
	}
	return NULL;									// Ak sa obrzok nenatal vrti NULL
}

int LoadGLTextures()								// Nata obrzky a uloi ako textury
{
	int Status=TRUE,i;								// indikator
	AUX_RGBImageRec *TextureImage;					// miesto pre truktru

	for(i=0;i<NUMBER_TEXTURE;i++)
	{	
		TextureImage=NULL;
		if (TextureImage=LoadBMP(texture_name[i]))
		{
			glGenTextures(1, &texture[i]);						//generovanie cislel pre textury
			glBindTexture(GL_TEXTURE_2D, texture[i]);			//vyber textury
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);		//nastavenie filtra
			glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);		//nastavenie filtra
				//nacitanie textury do (grafickej) karty
			glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage->sizeX, TextureImage->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage->data);
		}
		else 
		{	MessageBox(NULL,"Chyba natania obrzka.",texture_name[i],MB_ICONERROR);Status=false;}

		if (TextureImage)									// Ak textura existuje
		{
			if (TextureImage->data)free(TextureImage->data);// ak existuju data uvoni z pamte
			free(TextureImage);								// uvoni truktru
		}
	}
	return Status;
}
/*
int LoadGLTextures()		// Load Bitmaps And Convert To Textures
{
	HANDLE hBMP;
   BITMAP ImgInfo;
   int i;
   glGenTextures(NUMBER_TEXTURE, &texture[0]); 	// Create The Texture
   for(i=0;i!=NUMBER_TEXTURE;i++)
   {  hBMP=LoadImage(hInstance,texture_name[i],IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION|LR_LOADFROMFILE);
   	if(!hBMP){MessageBox(hWnd,"Load image fail.",texture_name[i],MB_ICONERROR);return false;}
   	GetObject(hBMP,sizeof(BITMAP),&ImgInfo);
   	glBindTexture(GL_TEXTURE_2D, texture[i]);
      glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
		glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		glTexImage2D(GL_TEXTURE_2D, 0, 3, ImgInfo.bmWidth, ImgInfo.bmHeight, 0, GL_BGR_EXT, GL_UNSIGNED_BYTE,ImgInfo.bmBits);
      DeleteObject(hBMP);
   }
   return true;
}
*/

int  DrawGLSceneDemo(GLvoid)
{float scale,pom;
float ang_s_mercury,ang_s_venus,ang_s_earth,ang_s_moon,ang_s_mars;  //ANGle_around Sun_PLANET (orbital)
float ang_mercury,ang_venus,ang_earth,ang_moon,ang_mars,ang_sun;   //ANGle_PLANET (rotation)

  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT );	// Clear Screen And Depth Buffer
  ChangeCameraPositionDemo();
  if(polygonmode) glPolygonMode(GL_FRONT_AND_BACK,GL_LINE);
  if(keys[VK_SPACE]){if(menu)menu=0;else menu=1; keys[VK_SPACE]=0;}
  if(optimalization)if(frame>1)
  {
  if(fps>50.0){if(sphere_split_y<40){sphere_split_y+=2;change_split=1;frame=0;}}
  else if(fps<25.0)if(sphere_split_y>8){sphere_split_y-=2;change_split=1;frame=0;}
  }
  if(change_split)
  {
    box[0]=BuildListsPaintBall(1.0f,2*sphere_split_y,sphere_split_y,box[0]);
    if(change_split==2){ box[1]=BuildListsStars(box[1]);
	box[2]=BuildListsLines(box[2]);}
    change_split=0;
  }
  stime=(float)TimerGetTime(&time_);
  if(rotate_s==1)			//calculation angle for rotate planets around sun
  {  ang_s_mercury=360.0f*stime*yearsec*piover180*365.256f/87.969f;
     ang_s_venus=  360.0f*stime*yearsec*piover180*365.256f/224.701f;
     ang_s_earth=  360.0f*stime*yearsec*piover180*365.256f/365.256f; //365.256 rotate around sun  for 1 year
     ang_s_moon=   360.0f*stime*yearsec*piover180*365.256f/27.32166f;
     ang_s_mars=   360.0f*stime*yearsec*piover180*365.256f/686.98f;
  }
  else if(rotate_s==2)
  {  ang_s_mercury=0;ang_s_venus=0;ang_s_earth=0;ang_s_moon=0;ang_s_mars=0;rotate_s=0;  }

  if(rotate)        //calculation angle for rotate planets
  {  ang_mercury=360.0f*stime*yearsec*365.256f/58.6462f;
     ang_venus= -360.0f*stime*yearsec*365.256f/243.0187f ;
     ang_earth=  360.0f*stime*yearsec*365.256f/0.99727f;      //0.99727 (or 1.0 ?) rotate for 1 day
     ang_moon=   360.0f*stime*yearsec*365.256f/27.32166f;
     ang_mars=   360.0f*stime*yearsec*365.256f/1.025957f;
     ang_sun	=360.0f*stime*yearsec*365.256f/25.0f;          //25-36
  }
  if(sound==1 & stime>53.3f & stime<60.0f){PlaySound("data/impact.wav", NULL, SND_ASYNC);sound=2;}
  else if(sound==2 & stime>60.0f)sound=1;

  glColor3f(1,1,1);
  glPushMatrix();
  if(stime<4){
  if(rotate)glRotatef(ang_sun,0,1,0);
  scale=scale_sun*696;glScalef(scale,scale,scale);
  glBindTexture(GL_TEXTURE_2D, texture[1]);  //sun
  glCallList(box[0]);
  }

  if(light)glEnable(GL_LIGHTING);
  if(stime<3 | (stime>24 & stime <28) ){
  glPopMatrix();glPushMatrix();
  if(rotate_s) glTranslatef(57900*scale_distance*(float)cos(ang_s_mercury),0.0f,-57900*scale_distance*(float)sin(ang_s_mercury));
  else glTranslatef(57900 *scale_distance,0.0f,0.0f);
  LightPosition[0]=-(float)cos(ang_s_mercury);
  LightPosition[2]=(float)sin(ang_s_mercury);
  glLightfv ( GL_LIGHT0,GL_POSITION, LightPosition  );// Position The Light
  //glRotatef(-0.1,0,0,-1);
  if(rotate)glRotatef(ang_mercury,0,1,0);
  scale=scale_planet*2.46f;glScalef(scale,scale,scale);
  glBindTexture(GL_TEXTURE_2D, texture[2]);    //mercury
  glCallList(box[0]);
  }

  if(stime<5 | (stime>12 & stime<30)){
  glPopMatrix();glPushMatrix();
  if(rotate_s)  glTranslatef(108200*scale_distance*(float)cos(ang_s_venus),0.0f,-108200*scale_distance*(float)sin(ang_s_venus));
  else glTranslatef(108200*scale_distance,0.0f,0.0f);
  LightPosition[0]=-(float)cos(ang_s_venus);
  LightPosition[2]=(float)sin(ang_s_venus);
  glLightfv ( GL_LIGHT0,GL_POSITION, LightPosition  );// Position The Light
  glRotatef(-3,0,0,-1);
  if(rotate)glRotatef(ang_venus,0,1,0);
  scale=scale_planet*6.05f;glScalef(scale,scale,scale);
  glBindTexture(GL_TEXTURE_2D, texture[3]);     //venus
  glCallList(box[0]);
  }

  if(stime>53.3f)ang_s_earth=52.53781f*piover180;
  glPopMatrix();glPushMatrix();
  if(rotate_s)  glTranslatef(149600*scale_distance*(float)cos(ang_s_earth),0.0f,-149600*scale_distance*(float)sin(ang_s_earth));
  else glTranslatef(149600*scale_distance,0.0f,0.0f);
  LightPosition[0]=-(float)cos(ang_s_earth);
  LightPosition[2]=(float)sin(ang_s_earth);
  glLightfv ( GL_LIGHT0,GL_POSITION, LightPosition  );// Position The Light
  glRotatef(23.0f,0,0,-1);
  if(rotate)glRotatef(ang_earth,0,1,0);
  scale=scale_planet*6.378f;glScalef(scale,scale,scale);
  glBindTexture(GL_TEXTURE_2D, texture[4]);    //earth
  glCallList(box[0]);

  if(showclouds)
  { glEnable(GL_BLEND);
    scale=1.01f;glScalef(scale,scale,scale);
	glBindTexture(GL_TEXTURE_2D, texture[9]);    //earth clouds
	if(stime<70.0f)glCallList(box[0]);
    glDisable(GL_BLEND);
  }

  if(stime<35.0f)
  { glPopMatrix();glPushMatrix();
  if(rotate_s)  glTranslatef(149600*scale_distance*(float)cos(ang_s_earth)+384*scale_moon*scale_distance*(float)cos(ang_s_moon),0.0f,-149600*scale_distance*(float)sin(ang_s_earth)-384*scale_moon*scale_distance*(float)sin(ang_s_moon));
  else glTranslatef((149600+384*scale_moon)*scale_distance,0.0f,0.0f);
  //glRotatef(1.5424,0,0,-1);
  LightPosition[0]=-149600*scale_distance*(float)cos(ang_s_earth)+384*scale_moon*scale_distance*(float)cos(ang_s_moon);
  LightPosition[2]=149600*scale_distance*(float)sin(ang_s_earth)-384*scale_moon*scale_distance*(float)sin(ang_s_moon);
  glLightfv ( GL_LIGHT0,GL_POSITION, LightPosition  );// Position The Light
  if(rotate)glRotatef(ang_moon+90.0f,0,1,0);
  scale=scale_planet*1.738f;glScalef(scale,scale,scale);
  glBindTexture(GL_TEXTURE_2D, texture[5]);    //moon
  glCallList(box[0]);
  }

  if(stime<11 | (stime>25 & stime<30)){
  if(227900*scale_distance<100)
  {  glPopMatrix();glPushMatrix();
     if(rotate_s)glTranslatef(227900*scale_distance*(float)cos(ang_s_mars),0.0f,-227900*scale_distance*(float)sin(ang_s_mars));
     else glTranslatef(227900*scale_distance,0.0f,0.0f);
     LightPosition[0]=-(float)cos(ang_s_mars);
     LightPosition[2]=(float)sin(ang_s_mars);
     glLightfv ( GL_LIGHT0,GL_POSITION, LightPosition  );// Position The Light
     glRotatef(25.0,0,0,-1);
     if(rotate)glRotatef(ang_mars,0,1,0);
     scale=scale_planet*3.4f;glScalef(scale,scale,scale);
     glBindTexture(GL_TEXTURE_2D, texture[6]);    //mars
     glCallList(box[0]);
  }}

  if(stime>31 & stime<55)
  {	  glPopMatrix();glPushMatrix();
	  glTranslatef(80.0f-( (stime-31.0f)*36.26f/24.0f ),0.0f,-(stime-31.0f)*60.678f/24.0f );
	  LightPosition[0]=-80.0f+( (stime-31.0f)*36.26f/24.0f );
	  LightPosition[2]=( (stime-31.0f)*60.678f/23.0f );
	  glLightfv ( GL_LIGHT0,GL_POSITION, LightPosition  );// Position The Light
	  scale=scale_planet;glScalef(scale,scale,scale);
	  glBindTexture(GL_TEXTURE_2D, texture[5]);     //asteroid
	  glCallList(box[0]);
  }
  
  if(light)glDisable(GL_LIGHTING);
  glDisable(GL_BLEND);
  glPopMatrix();glPushMatrix();
  glColor3f(1,1,1);
  glBlendFunc(GL_ONE,GL_ONE);
  glEnable(GL_BLEND);
  glBindTexture(GL_TEXTURE_2D, texture[10]);
  glCallList(box[1]);				//stars
  glDisable(GL_BLEND);
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_COLOR);

  if(conslines){
    glPopMatrix();glPushMatrix();
    glDisable(GL_TEXTURE_2D);
    glColor3f(1,1,1);
    glCallList(box[2]);				//constalation lines
    glEnable(GL_TEXTURE_2D);
  }

  glEnable(GL_BLEND);
  if(stime>53.3f)
  {	  glPopMatrix();glPushMatrix();
      glTranslatef(46.62f,0,-56.386f);
	  if(stime<67.0f)scale=0.3f*scale_planet*(stime-50.0f);else scale=0.3f*scale_planet*(67.0f-50.0f);
	  glScalef(scale,scale,scale);
	  glRotatef(20.51f,0,1,0);
	  glBindTexture(GL_TEXTURE_2D, texture[12]);     //impact
	  glColor4f( (72-stime)/18.7f,(72-stime)/16.7f,(72-stime)/18.7f,1);
	  glBegin(GL_TRIANGLE_STRIP);
        glTexCoord2f(0,0);
		glVertex3f(-1,-1,1);
		glTexCoord2f(1,0);
		glVertex3f(1,-1,1);
		glTexCoord2f(0,1);
		glVertex3f(-1,1,1);
		glTexCoord2f(1,1);
		glVertex3f(1,1,1);
	  glEnd();
  }
  if(stime<=75.0f & stime>60.0f)
  {glPopMatrix();glPushMatrix();
   glTranslatef(46.62f,0,-56.386f);
   if(stime<=71.0f)scale=0.3f*scale_planet*(stime-50.0f);else scale=0.3f*scale_planet*(71.0f-50.0f);
   glScalef(scale,scale,scale);
   glRotatef(20.51f,0,1,0);
   glBindTexture(GL_TEXTURE_2D, texture[12]);
   glColor4f(1,0,0,1);
   glBegin(GL_TRIANGLE_STRIP);
	glTexCoord2f(0,0);
	glVertex3f(-0.8f,-0.8f,1.1f);
	glTexCoord2f(1,0);
	glVertex3f(0.8f,-0.8f,1.1f);
	glTexCoord2f(0,1);
	glVertex3f(-0.8f,0.8f,1.1f);
	glTexCoord2f(1,1);
	glVertex3f(0.8f,0.8f,1.1f);
   glEnd();
  }
  if(stime>53.3f)
  {	  glPopMatrix();glPushMatrix();
      glTranslatef(46.62f,0,-56.386f);
	  if(stime<67.0f)scale=0.3f*scale_planet*(stime-50.0f);else scale=0.3f*scale_planet*(67.0f-50.0f);
	  glScalef(scale,scale,scale);
	  glRotatef(20.51f,0,1,0);
	  glColor4f( (72-stime)/18.7f,(72-stime)/16.7f,(72-stime)/18.7f,1);
	  glBindTexture(GL_TEXTURE_2D, texture[11]);
      glBegin(GL_TRIANGLE_STRIP);
        glTexCoord2f(0,0);
		glVertex3f(-3.5,-3.5,3);
		glTexCoord2f(1,0);
		glVertex3f(3.5,-3.5,3);
		glTexCoord2f(0,1);
		glVertex3f(-3.5,3.5,3);
		glTexCoord2f(1,1);
		glVertex3f(3.5,3.5,3);
	  glEnd();
	  glColor4f((72-stime)/18.7f,(72-stime)/18.7f,0,1);
	  glBegin(GL_TRIANGLE_STRIP);
		glTexCoord2f(0,0);
		glVertex3f(-3.5,-3.5,3);
		glTexCoord2f(1,0);
		glVertex3f(3.5,-3.5,3);
		glTexCoord2f(0,1);
		glVertex3f(-3.5,3.5,3);
		glTexCoord2f(1,1);
		glVertex3f(3.5,3.5,3);
	  glEnd();
  }
  if(stime<54.1f & stime>53.3f)
  {glPopMatrix();glPushMatrix();
   glTranslatef(46.62f,0,-56.386f);
   scale=100*(54.1f-stime);glScalef(scale,scale,scale);
   glRotatef(20.51f,0,1,0);
   glColor4f(1,1,1,1);
  glBegin(GL_TRIANGLE_STRIP);
    glTexCoord2f(0,0);
    glVertex3f(-1,-1,0.19f);
    glTexCoord2f(1,0);
    glVertex3f(1,-1,0.19f);
    glTexCoord2f(0,1);
    glVertex3f(-1,1,0.19f);
    glTexCoord2f(1,1);
    glVertex3f(1,1,0.19f);
  glEnd();
  }
  glDisable(GL_BLEND);

  
  if(stime<4 | (stime>25 & stime<27) ){
  glPopMatrix();glPushMatrix();
  scale=scale_sun*697;glScalef(scale,scale,scale); //696
  glBindTexture(GL_TEXTURE_2D, texture[8]);
  glColor4f(1,1,1,1);
  glEnable(GL_BLEND);
  scale=(float)sqrt(pos_x*pos_x+pos_z*pos_z);
  if(scale==0)scale=1;
  pom=0.145f*(13.94f*scale-13.94f*13.94f)/scale;
  glBegin(GL_TRIANGLE_STRIP);
    glTexCoord2f(0,0);
    glVertex3f(-pom*pos_z/scale+pos_x/scale,-pom,pom*pos_x/scale+pos_z/scale);
    glTexCoord2f(1,0);
    glVertex3f(pom*pos_z/scale+pos_x/scale,-pom,-pom*pos_x/scale+pos_z/scale);
    glTexCoord2f(0,1);
    glVertex3f(-pom*pos_z/scale+pos_x/scale,pom,pom*pos_x/scale+pos_z/scale);
    glTexCoord2f(1,1);
    glVertex3f(pom*pos_z/scale+pos_x/scale,pom,-pom*pos_x/scale+pos_z/scale);
  glEnd();
  glDisable(GL_BLEND);
  }

   glPopMatrix();//glPushMatrix();
   fps=(float)1.0f /(float)TimerGetTime(&timer1);
   TimerReset(&timer1);

   if(polygonmode)glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);
   if(showFps | showDel | showPos | showAngles)write_text();		//write on screen FPS,...
   if(menu)ShowMenu();
	frame++;
	return TRUE;										// Everything Went OK
}

inline void write_text(void)
{char text[30];
   	glBindTexture(GL_TEXTURE_2D, texture[0]);	// Select Our Font Texture
    glDisable(GL_DEPTH_TEST);					//disable Z - buffer
    glEnable(GL_BLEND);							// Enable Blending
  	glMatrixMode(GL_PROJECTION);				// Select The Projection Matrix
	glPushMatrix();
	glLoadIdentity();							// Reset The Projection Matrix
	glOrtho(0,screen_x,0,screen_y,-1,1);		// Set Up An Ortho Screen
	glMatrixMode(GL_MODELVIEW);					// Select The Modelview Matrix
   glColor4f(1,1,1,1);

   if(showFps){  gcvt( (double)fps, 4, text);glPrintFast(5,550,text,0);}

   if(showDel)
   { itoa(4*sphere_split_y*sphere_split_y, text, 10);glPrintFast(113,410,text,0);glPrintFast(5,410,"Trian sp:",0);
   }
   if(showAngles)
   { gcvt( (double)angle_x, 3, text);glPrintFast(106,470,text,0);glPrintFast(5,470,"Angle X:",0);
     gcvt( (double)angle_y, 3, text);glPrintFast(106,450,text,0);glPrintFast(5,450,"Angle Y:",0);
     gcvt( (double)angle_z, 3, text);glPrintFast(106,430,text,0);glPrintFast(5,430,"Angle Z:",0);
   }

   if(showPos)
   { gcvt( (double)pos_x, 3, text);glPrintFast(35,530,text,0);glPrintFast(5,530,"X:",0);
     gcvt( (double)pos_y, 3, text);glPrintFast(35,510,text,0);glPrintFast(5,510,"Y:",0);
     gcvt( (double)pos_z, 3, text);glPrintFast(35,490,text,0);glPrintFast(5,490,"Z:",0);
   }

   glMatrixMode(GL_PROJECTION);			// Select The Projection Matrix
   glPopMatrix();
   glMatrixMode(GL_MODELVIEW);			// Select The Modelview Matrix
   glDisable(GL_BLEND);					// Disable Blending
   glEnable(GL_DEPTH_TEST);
}