#include "init.h"
#include <stdio.h>
#include <stdlib.h>

#define STARS_NUM	251
#define LINES_NUM 646
#define PI 3.14159265359
extern const float piover180 =  0.01745329251994f; // pi/180

GLvoid glPrint(GLint , GLint , char *, int );

typedef struct {float angle_x,angle_y,size,r,g,b;}STAR_STRUCT;
STAR_STRUCT star[STARS_NUM];
typedef struct {float ang_y0,ang_x0,ang_y1,ang_x1;}LINE_STRUCT;
LINE_STRUCT line[LINES_NUM];

int LoadStars(void)
{FILE* sub;
char tmp[50],tmp1[15],tmp2[15];
int ch,i,j,k;
float tmpf1,tmpf2;
sub=fopen("data/Starname.csv","r");
if(sub==NULL)return 0;
do {if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}}while(ch!=0xa);		//read first line
for(k=0;k<STARS_NUM;k++)
{  for(j=0;j<5;j++){ch=0;						//4X
    for(i=0;ch!=0x2C;i++)
    {if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}tmp[i]=(char)ch;}tmp[i]='\0'; //read "xxxxxxxx,"
  }
  ch=0;
  for(i=0;ch!=0x2C;i++)
  {if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}tmp[i]=(char)ch;}tmp[i]='\0'; //read magnitude
  star[k].size=(float)atof(tmp);
  if(star[k].size<0)star[k].size=-star[k].size;
  ch=0;
  for(i=0;ch!=0x2C;i++){if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}tmp[i]=(char)ch;}tmp[i]='\0'; //spectral class
  switch(tmp[0]){
    case 'M':{star[k].r=1.0f;star[k].g=0.9f;star[k].b=0.9f;break;}
    case 'K':{star[k].r=1.0f;star[k].g=0.95f;star[k].b=0.9f;break;}
    case 'G':{star[k].r=1.0f;star[k].g=1.0f;star[k].b=0.9f;break;}
    case 'F':{star[k].r=0.95f;star[k].g=1.0f;star[k].b=0.95f;break;}
    case 'A':{star[k].r=1.0f;star[k].g=1.0f;star[k].b=1.0f;break;}
    case 'B':{star[k].r=0.95f;star[k].g=0.95f;star[k].b=1.0f;break;}
    default :{star[k].r=1.0f;star[k].g=1.0f;star[k].b=1.0f;break;}
  }
  //star[k].r=1.0f;star[k].g=1.0f;star[k].b=1.0f;
  ch=0;
  for(i=0;ch!=0x2C;i++){if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}tmp[i]=(char)ch;} tmp[i]='\0'; //Right ascension
  for(i=0;tmp[i]!='h';i++)
  tmp1[i]=tmp[i];tmp1[i]='\0';
  i++;j=0;
  while((tmp[i])!='m'){tmp2[j]=tmp[i];i++;j++;}
  tmp2[j]='\0';
  tmpf1=(float)atof(tmp1);
  tmpf2=(float)atof(tmp2);
  tmpf1=(tmpf1+tmpf2/60.0f)*360.0f/24.0f;
  star[k].angle_y=tmpf1;

  ch=0;
  for(i=0;ch!=0x2C;i++){if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}tmp[i]=(char)ch;} tmp[i]='\0'; //Declination
  for(i=0;(tmp[i])!='';i++)
  tmp1[i]=tmp[i];tmp1[i]='\0';
  i++;j=0;
  while((tmp[i])!=0x27){tmp2[j]=tmp[i];i++;j++;}
  tmp2[j]='\0';
  tmpf1=(float)atof(tmp1);
  tmpf2=(float)atof(tmp2);
  if(tmpf1>=0)star[k].angle_x=tmpf1+tmpf2/60.0f;
    else star[k].angle_x=tmpf1-tmpf2/60.0f;

  do {if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}} while(ch!=0xa);
}
fclose(sub);
return 1;
}

GLuint BuildListsStars(GLuint boxDisplay)
{int k;
float pt[4][3],v[3],a[3],b[3];
float r,absolut,absolut1;
if(boxDisplay)glDeleteLists(boxDisplay,1);
boxDisplay=glGenLists(1);									// Generate 1 Different Lists
glNewList(boxDisplay,GL_COMPILE);							// Start With The Box List
  glBegin(GL_TRIANGLES);
for(k=0;k<STARS_NUM;k++)
{
  glColor3f(star[k].r,star[k].g,star[k].b);
  r=200.0f*(float)cos(star[k].angle_x*piover180);
  a[0]=r*(float)cos((90-star[k].angle_y)*piover180);
  a[1]=200.0f*(float)sin(star[k].angle_x*piover180);
  a[2]=r*(float)sin((90-star[k].angle_y)*piover180);

  v[0]=r*(float)cos((90-star[k].angle_y-star[k].size)*piover180);
  v[1]=200.0f*(float)sin(star[k].angle_x*piover180);
  v[2]=r*(float)sin((90-star[k].angle_y-star[k].size)*piover180);

  b[0]=v[0]-a[0];
  b[1]=v[1]-a[1];
  b[2]=v[2]-a[2];
  absolut1=(float)sqrt(b[0]*b[0]+b[1]*b[1]+b[2]*b[2]);
  if(absolut1>0)  //avoid zero division error
     {b[0]=b[0]/absolut1;
      b[1]=b[1]/absolut1;
      b[2]=b[2]/absolut1;}

  v[0]=a[1]*b[2]-a[2]*b[1];		//vector product
  v[1]=a[2]*b[0]-a[0]*b[2];
  v[2]=a[0]*b[1]-a[1]*b[0];

  absolut=(float)sqrt(v[0]*v[0]+v[1]*v[1]+v[2]*v[2]);
    if(absolut>0)  //avoid zero division error
     {v[0]=v[0]/absolut;
      v[1]=v[1]/absolut;
      v[2]=v[2]/absolut;}

  b[0]=b[0]*star[k].size/2.0f;
  b[1]=b[1]*star[k].size/2.0f;
  b[2]=b[2]*star[k].size/2.0f;
  v[0]=v[0]*star[k].size/2.0f;
  v[1]=v[1]*star[k].size/2.0f;
  v[2]=v[2]*star[k].size/2.0f;

  pt[0][0]=a[0]-b[0]-v[0];
  pt[0][1]=a[1]-b[1]-v[1];
  pt[0][2]=a[2]-b[2]-v[2];

  pt[1][0]=a[0]+b[0]-v[0];
  pt[1][1]=a[1]+b[1]-v[1];
  pt[1][2]=a[2]+b[2]-v[2];

  pt[2][0]=a[0]+b[0]+v[0];
  pt[2][1]=a[1]+b[1]+v[1];
  pt[2][2]=a[2]+b[2]+v[2];

  pt[3][0]=a[0]-b[0]+v[0];
  pt[3][1]=a[1]-b[1]+v[1];
  pt[3][2]=a[2]-b[2]+v[2];

//  glBegin(GL_TRIANGLE_STRIP);       //GL_TRIANGLES);
      glTexCoord2f(0,0);
      glVertex3f(pt[0][0],pt[0][1],pt[0][2]);
      glTexCoord2f(1,0);
      glVertex3f(pt[1][0],pt[1][1],pt[1][2]);
      glTexCoord2f(0,1);
      glVertex3f(pt[3][0],pt[3][1],pt[3][2]);

        glTexCoord2f(1,0);
        glVertex3f(pt[1][0],pt[1][1],pt[1][2]);
      glTexCoord2f(1,1);
      glVertex3f(pt[2][0],pt[2][1],pt[2][2]);
        glTexCoord2f(0,1);
        glVertex3f(pt[3][0],pt[3][1],pt[3][2]);
//  glEnd();
}
glEnd();
glEndList();
return boxDisplay;
}

int LoadConlines(void)
{FILE* sub;
char tmp[50];
int ch,i,k;

sub=fopen("data/Conlines.csv","r");
if(sub==NULL)return 0;
for(i=0;i<5;i++)		//5x
do {if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}}while(ch!=0xa);		//read line

for(k=0;k<LINES_NUM;k++)
{  for(i=0;ch!=0x2C;i++)
    {if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}tmp[i]=(char)ch;}tmp[i]='\0'; //read "xxxxxxxx,"

  ch=0;
  for(i=0;ch!=0x2C;i++){if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}tmp[i]=(char)ch;} tmp[i]='\0'; //Right ascension
  line[k].ang_y0=(float)atof(tmp)*360.0f/(24.0f*1000.0f);

  ch=0;
  for(i=0;ch!=0x2C;i++){if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}tmp[i]=(char)ch;} tmp[i]='\0'; //Declination
  line[k].ang_x0=(float)atof(tmp)/100.0f;

  ch=0;
  for(i=0;ch!=0x2C;i++){if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}tmp[i]=(char)ch;} tmp[i]='\0'; //Right ascension
  line[k].ang_y1=(float)atof(tmp)*360.0f/(24.0f*1000.0f);

  ch=0;
  for(i=0;ch!=0xa;i++){if((ch=fgetc(sub))==EOF){fclose(sub);return 0;}tmp[i]=(char)ch;} tmp[i]='\0'; //Declination
  line[k].ang_x1=(float)atof(tmp)/100.0f;
}
fclose(sub);
return 1;
}

GLuint BuildListsLines(GLuint boxDisplay)
{int k;
float pt[2][3];
float r0;

if(boxDisplay)glDeleteLists(boxDisplay,1);
boxDisplay=glGenLists(1);				// Generate 1 Different Lists
glNewList(boxDisplay,GL_COMPILE);		// Start With The Box List
glBegin(GL_LINES);
for(k=0;k<LINES_NUM;k++)
{
  r0=200.0f*(float)cos(line[k].ang_x0*piover180);
  pt[0][0]=r0*(float)cos((90-line[k].ang_y0)*piover180);
  pt[0][1]=200*(float)sin(line[k].ang_x0*piover180);
  pt[0][2]=r0*(float)sin((90-line[k].ang_y0)*piover180);

  r0=200.0f*(float)cos(line[k].ang_x1*piover180);
  pt[1][0]=r0*(float)cos((90.0f-line[k].ang_y1)*piover180);
  pt[1][1]=200.0f*(float)sin(line[k].ang_x1*piover180);
  pt[1][2]=r0*(float)sin((90.0f-line[k].ang_y1)*piover180);

//  glBegin(GL_LINES);
      glVertex3f(pt[0][0],pt[0][1],pt[0][2]);
      glVertex3f(pt[1][0],pt[1][1],pt[1][2]);
//  glEnd();
}
glEnd();
glEndList();
return boxDisplay;
}
