#include "init.h"
#include  "timer.h"

TIMER time_,timer1;

double int64_d(INT64__ x)
{return ( (double)x.LowPart+(double)x.HighPart*(double)4294967296.0f );}

void TimerInit(TIMER* timer)						// Initialize Our Timer (Get It Ready)
{  memset(timer, 0, sizeof(TIMER));				// Clear Our Timer Structure
	if (!QueryPerformanceFrequency((LARGE_INTEGER *) &(timer->frequency)))
	{  timer->performance_timer	= FALSE;					// Set Performance Timer To FALSE
		timer->mm_timer_start	= timeGetTime();			// Use timeGetTime() To Get Current Time
		timer->period		= (double)1.0f/1000.0f;		 // period=1ms Set Our Timer Resolution To .001f
	}
	else
	{ 	QueryPerformanceCounter((LARGE_INTEGER *) &(timer->performance_timer_start));
		timer->performance_timer	= TRUE;				// Set Performance Timer To TRUE
      timer->period 	= ( (double)1.0f )/ int64_d(timer->frequency) ;
	}
}

float TimerGetTime(TIMER* timer)
{INT64__ time;

 if (timer->performance_timer)
 {QueryPerformanceCounter((LARGE_INTEGER *) &time);
   return ( (float) ( int64_d(time) - int64_d(timer->performance_timer_start) )* (float)timer->period);
 }
 else	return( (float) ( timeGetTime() - timer->mm_timer_start) * (float)timer->period);
}

void TimerReset(TIMER* timer)
{
 if (timer->performance_timer)
     QueryPerformanceCounter((LARGE_INTEGER *) &(timer->performance_timer_start) );
 else timer->mm_timer_start=timeGetTime();
}